#ifndef	_APM_H_
#define	_APM_H_

#define	APM_VERSION_1_0	0x0100
#define	APM_VERSION_1_1	0x0101
#define	APM_VERSION_1_2	0x0102

/* APM device IDs */

enum
{
	APM_DEVICE_APM_BIOS       = 0x0000,
	APM_DEVICE_ALL            = 0x0001,
	APM_DEVICE_DISPLAY        = 0x0100,
	APM_DEVICE_STORAGE        = 0x0200,
	APM_DEVICE_PARALLEL       = 0x0300,
	APM_DEVICE_SERIAL         = 0x0400,
	APM_DEVICE_NETWORK        = 0x0500,
	APM_DEVICE_PCCARD_SOCKETS = 0x0600,
	APM_DEVICE_BATTERIES      = 0x8000
};

/* APM power states */

enum
{
	APM_STATE_ENABLED,
	APM_STATE_STANDBY,
	APM_STATE_SUSPEND,
	APM_STATE_OFF,
	APM_STATE_PROCESSING,
	APM_STATE_REJECTED
};

/* APM BIOS functions */

enum
{
	APM_FUNC_INSTALLATION_CHECK,
	APM_FUNC_REAL_CONN,
	APM_FUNC_PROT16_CONN,
	APM_FUNC_PROT32_CONN,
	APM_FUNC_DISCONN,
	APM_FUNC_CPU_IDLE,
	APM_FUNC_CPU_BUSY,
	APM_FUNC_SET_POWER_STATE,
	APM_FUNC_ENABLE_POWER_MGMT,
	APM_FUNC_RESTORE_DEFAULTS,
	APM_FUNC_GET_POWER_STATUS,
	APM_FUNC_GET_PM_EVENT,
	APM_FUNC_GET_POWER_STATE,
	APM_FUNC_ENABLE_DEVICE_POWER_MGMT,
	APM_FUNC_DRIVER_VERSION,
	APM_FUNC_ENGAGE_POWER_MGMT,
	APM_FUNC_GET_CAPABILITIES,
	APM_FUNC_RESUME_TIMER,
	APM_FUNC_RESUME_ON_RING,
	APM_FUNC_TIMER_REQUESTS,
	APM_FUNC_OEM = 0x80
};

#define	APM_FUNC_OFFSET	0x5300

/* APM BIOS errors */

enum
{
	APM_ERR_OK,
	APM_ERR_DISABLED,
	APM_ERR_REAL_CONN,
	APM_ERR_NOT_CONN,
	APM_ERR_PROT16_CONN = 5,
	APM_ERR_PROT16_UNSUPP,
	APM_ERR_PROT32_CONN,
	APM_ERR_PROT32_UNSUPP,
	APM_ERR_DEVICE_ID,
	APM_ERR_VALUE,
	APM_ERR_NOT_ENGAGED,
	APM_ERR_FUNC_UNSUPP,
	APM_ERR_RESUME_TIMER,
	APM_ERR_NOT_ENTER = 0x60,
	APM_ERR_NO_EVENTS = 0x80,
	APM_ERR_BIOS_ABSENT = 0x86
};

enum
{
	APM_EVENT_SYSTEM_STANDBY      = 1,
	APM_EVENT_SYSTEM_SUSPEND      = 2,
	APM_EVENT_NORMAL_RESUME       = 3,
	APM_EVENT_CRITICAL_RESUME     = 4,
	APM_EVENT_BATTERY_LOW         = 5,
	APM_EVENT_POWER_STATUS_CHANGE = 6,
	APM_EVENT_UPDATE_TIME         = 7,
	APM_EVENT_CRITICAL_SUSPEND    = 8,
	APM_EVENT_USER_STANDBY        = 9,
	APM_EVENT_USER_SUSPEND        = 10,
	APM_EVENT_STANDBY_RESUME      = 11,
	APM_EVENT_CAPABILITIES_CHANGE = 12
};

#endif
