#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include "logger.h"

int open_logger (const char *path, int flags)
{
	return open (path, O_WRONLY | O_APPEND | O_CREAT, 0644);
}

int close_logger (int fd)
{
	if (fd < 0)
		return -1;

	fsync (fd);
	return close (fd);
}

int vlogger (int fd, const char *format, va_list ap)
{
	char buf [LOG_MAX_LEN];
	size_t len;
	static int count = 0;

	if (fd < 0)
		return -1;

	if (++count >= LOG_SYNC_LINES)
	{
		fsync (fd);
		count = 0;
	}
	/* return value of vsprintf() is useless!! */
	vsprintf (buf, format, ap);
	buf [LOG_MAX_LEN - 1] = '\0';
	len = strlen (buf);
	return write (fd, buf, len);
}

int logger (int fd, const char *format, ...)
{
	va_list	ap;
	int	result;

	if (fd < 0)
		return -1;

	va_start (ap, format);
	result = vlogger (fd, format, ap);
	va_end (ap);
	return result;
}

