
#include <support/SupportDefs.h>
#include <drivers/Drivers.h>
#include <unistd.h>
#include <stdarg.h>
#include "logger.h"

#define	dprintf	dprintf_logger
#define	LOG_PATH	"/var/log/hogehoge.log"
extern int logfd;
void	dprintf_logger	(const char *format, ...);

int logfd = -1;

void	dprintf_logger	(const char *format, ...)
{
	va_list ap;
	
	va_start (ap, format);
	vlogger (logfd, format, ap);
	va_end (ap);
}

/* exported device driver routines */

_EXPORT status_t
init_hardware (void)
{
	/* W_OK fails */
	if (access (LOG_PATH, F_OK) >= 0)
		logfd = open_logger (LOG_PATH, 0);
	/*	:
		:
		:	*/
	close_logger (logfd);
}

_EXPORT status_t
init_driver (void)
{
	if (access (LOG_PATH, F_OK) >= 0)
		logfd = open_logger (LOG_PATH, 0);
	/*	:
		:
		:	*/
}

_EXPORT void
uninit_driver (void)
{
	/*	:
		:
		:	*/
	close_logger (logfd);
}
